// $Id: sztakidictOverlay.js,v 1.8 2004/03/03 23:18:21 jaap Exp $

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Jaap Haitsma.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * by the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Jaap Haitsma <jaap@haitsma.org>, Balazs E. Pataki <pataki@dsd.sztaki.hu>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// Uncomment DEBUG part and //log statements to have //logging to the console
// Furthermore you need to add the following two lines to prefs.js to see
// the //logging in the shell where you started the browser
// user_pref("browser.dom.window.dump.enabled", true);
// user_pref("javascript.options.showInConsole", true);

////////////////////////////////////////////////////////////////////////////
// Debug part
////////////////////////////////////////////////////////////////////////////
/*
function //log(str){
    dump(str + "\n");
}

function dumpObject(obj){
    dump("\n dumping object contents\n");
    for(i in obj){
        dump(i + " = " + obj[i] + "\n");
    }
    dump("\n");
}
*/
////////////////////////////////////////////////////////////////////////////

//alert("hey");
const SZTAKIDICT_NUM_DICTIONARIES=4;

// Every time a new browser window is made sztakidictSearchInit will be called
window.addEventListener("load",sztakidictSearchInit,false);

var sztakidictSearchStrBundle;
var sztakidictWindow = '';

// This holds the object for accessing the preferences stored in prefs.js
var sztakidictSearchPrefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("sztakidict.");

var sztakidictInThunderbird=false;



function sztakidictCheckPreVersion0_4Installed(){
    //log("checkPreVersion0_4Installed()");
    if (sztakidictSearchPrefs.prefHasUserValue("url")){
        //log("checkPreVersion0_4Installed(): old preferences found in prefs.js");
        // Copy values         
        sztakidictSearchPrefs.setCharPref("url1", sztakidictSearchPrefs.getCharPref("url"));
        sztakidictSearchPrefs.setCharPref("menutext1", sztakidictSearchPrefs.getCharPref("menuitem.label"));
        sztakidictSearchPrefs.setCharPref("accesskey1", sztakidictSearchPrefs.getCharPref("menuitem.accesskey"));
        // Remove preferences
        sztakidictSearchPrefs.clearUserPref("url");
        sztakidictSearchPrefs.clearUserPref("menuitem.label");
        sztakidictSearchPrefs.clearUserPref("menuitem.accesskey");
    }
}



function sztakidictSearchInit() {
    //log("sztakidictSearchInit()");
	//alert("sztakidictSearchInit");

    if (document.getElementById("messagePaneContext") || document.getElementById("msgComposeContext")){
        sztakidictInThunderbird = true;
    } 
		
    sztakidictSearchStrBundle = document.getElementById("sztakidict_string_bundle");

    sztakidictCheckPreVersion0_4Installed();

    if (!sztakidictSearchPrefs.prefHasUserValue("menutext1")){
        //log("sztakidictSearchInit(): no preferences found in prefs.js taking defaults");
        // Assign default values
        sztakidictSearchPrefs.setCharPref("url1", sztakidictSearchStrBundle.getString("sztakidict.default.URL"));
        sztakidictSearchPrefs.setCharPref("menutext1", sztakidictSearchStrBundle.getString("sztakidict.default.menutext"));
        sztakidictSearchPrefs.setCharPref("accesskey1", sztakidictSearchStrBundle.getString("sztakidict.default.accesskey"));
        // pataki@dsd.sztaki.hu: added these lines
		sztakidictSearchPrefs.setCharPref("url2", sztakidictSearchStrBundle.getString("sztakidict.default.URL2"));
        sztakidictSearchPrefs.setCharPref("menutext2", sztakidictSearchStrBundle.getString("sztakidict.default.menutext2"));
        sztakidictSearchPrefs.setCharPref("accesskey2", sztakidictSearchStrBundle.getString("sztakidict.default.accesskey2"));
	}
	// pataki@dsd.sztaki.hu: changed i=2 to i=3
    for (i=3; i<=SZTAKIDICT_NUM_DICTIONARIES; i++){
        if (!sztakidictSearchPrefs.prefHasUserValue("menutext"+i)){
            sztakidictSearchPrefs.setCharPref("url"+i, "");
            sztakidictSearchPrefs.setCharPref("menutext"+i, "");
            sztakidictSearchPrefs.setCharPref("accesskey"+i, "");
        }
    }

    try{
		if (document.getElementById("contentAreaContextMenu"))
			document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",onSztakidictSearchPopup,false);
	   	if (document.getElementById("messagePaneContext"))
	   		document.getElementById("messagePaneContext").addEventListener("popupshowing",onSztakidictSearchPopup,false);
	   	if (document.getElementById("msgComposeContext"))
	   		document.getElementById("msgComposeContext").addEventListener("popupshowing",onSztakidictSearchPopup,false);	   	   
    }
    catch(e){
		//alert(e);
       // Do nothing. sztakidictSearchInit() is also called when the preferences dia//log is called and there
       // document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",onSztakidictSearchPopup,false);
       // fails
    }
}



function onSztakidictSearchPopup() {
	var selectedText;
        selectedText = sztakidictSearchGetSelectedText("");
        if (selectedText.length != 0 ){
           if (selectedText.length > 18){
               selectedText = selectedText.substr(0,14) + "...";
           }
	}
	else {
		// If there's no selection use a pormpt text
		selectedText = sztakidictSearchStrBundle.getString("sztakidict.menutext.prompt");
	}

	var menuText;
	var item;
	for (i=1; i<=SZTAKIDICT_NUM_DICTIONARIES; i++){
		menuText = sztakidictSearchPrefs.getCharPref("menutext"+i);
		item = document.getElementById("context_sztakidictselect"+i);
		item.hidden = true;
		if (menuText!=""){
			item.hidden = false;
			menuText = menuText.split("$");
			menuText = menuText[0] + selectedText + menuText[1];
			item.setAttribute("label", menuText);
			item.setAttribute("accesskey", sztakidictSearchPrefs.getCharPref("accesskey"+i));
		}
	}

}



function onSztakidictSearch(n){
    var urlN = sztakidictSearchPrefs.getCharPref("url"+n);
    var url = urlN.split("$");
    var searchText;
    searchText = sztakidictSearchGetSelectedText("");
    if ( searchText.length != 0 ) {
	  searchText = sztakidictSearchGetSelectedText("+");
    }
	else {
		var p;
		// If no selection, popup a prompt window
		if (urlN.indexOf("ENG:HUN") != -1)
			p = sztakidictSearchStrBundle.getString("sztakidict.prompt.en_hu");
		else if (urlN.indexOf("HUN:ENG"))
			p = sztakidictSearchStrBundle.getString("sztakidict.prompt.hu_en");
		else
			p = sztakidictSearchStrBundle.getString("sztakidict.prompt.generic");
        searchText = prompt(p+':')
		searchText = sztakidictCleanSearchText(searchText, "+");
	}
	url = url[0] +  escape(searchText) + url[1];
	sztakidictPopItUp(url+"&in_mozcontext=0.2&in_bookmarklet=1");
}



// szaboaster@gmail.com
function sztakidictGetTextSelected(){

	var selection;

        var node = document.popupNode;

	var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow,
	    			'document',
	   		 	'getSelection()');

	if ((node instanceof HTMLTextAreaElement) ||
	    ((node instanceof HTMLInputElement) && (node.type == "text")))  {
	     selection = node.value.substring(node.selectionStart, node.selectionEnd);
	} else {
          selection = focusedWindow.getSelection().toString();
	}

   return selection;

}



function sztakidictSearchGetSelectedText(concationationChar)
{
    var text = sztakidictGetTextSelected();
	return sztakidictCleanSearchText(text, concationationChar)
}



function sztakidictCleanSearchText(text, concationationChar){
    //log("sztakidictSearchGetSelectedText()");

    var charactersToRemove = "\&()[]{}\",.!?':\;";
    // szaboaster@gmail.com
    var searchTextArray = text.split(" ");

    for (i=0; i<searchTextArray.length; i++){
        var firstChar=searchTextArray[i].charAt(0);
        while ((charactersToRemove.indexOf(firstChar) != -1) && (searchTextArray[i].length!=0)){
            
            searchTextArray[i]=searchTextArray[i].substring(1, searchTextArray[i].length);       
            firstChar=searchTextArray[i].charAt(0);
        } 

        var lastChar=searchTextArray[i].charAt(searchTextArray[i].length - 1);

        while ((charactersToRemove.indexOf(lastChar) != -1) && (searchTextArray[i].length!=0)){
            searchTextArray[i]=searchTextArray[i].substring(0, searchTextArray[i].length - 1);
            lastChar=searchTextArray[i].charAt(searchTextArray[i].length - 1);
        } 
    }
    i=0;

    while (searchTextArray[i].length==0){
        i++;
        if (i>(searchTextArray.length-1)){
            return "";
        }
    }

    var cleanedText = searchTextArray[i];
    i++;
    while (i<searchTextArray.length){
        cleanedText = cleanedText + concationationChar + searchTextArray[i];
        i++;
    }

    return cleanedText;
}



function sztakidictSearchSaveSettings(){
    //log("sztakidictSearchSaveSettings()");

    var url;
    var menuText;
    var accessKey;
    for (i=1; i<=SZTAKIDICT_NUM_DICTIONARIES; i++){
        url = document.getElementById("sztakidictURL"+i).value;
        menuText = document.getElementById("sztakidictMenuText"+i).value;
        accessKey = document.getElementById("sztakidictAccessKey"+i).value;
        if (menuText != ""){       
            if (!sztakidictSearchCheckDollarSign(menuText)){
                alert(sztakidictSearchStrBundle.getString("sztakidict.menutext.error1")  + " " + i
                      + " " + sztakidictSearchStrBundle.getString("sztakidict.menutext.error2"));
                return false;
            }

            if ((menuText.indexOf(accessKey) == -1) || (accessKey == "")){
                alert(sztakidictSearchStrBundle.getString("sztakidict.accesskey.error1") + " " + i
                      + " " + sztakidictSearchStrBundle.getString("sztakidict.accesskey.error2"));
                return false;
            }

            if (!sztakidictSearchCheckDollarSign(url)){
                alert(sztakidictSearchStrBundle.getString("sztakidict.URL.error1") + " " + i
                  + " " + sztakidictSearchStrBundle.getString("sztakidict.URL.error2"));
                return false;
            }

        }
        sztakidictSearchPrefs.setCharPref("url"+i, url);
        sztakidictSearchPrefs.setCharPref("menutext"+i, menuText);
        sztakidictSearchPrefs.setCharPref("accesskey"+i, accessKey);

    }
    return true;
}



function sztakidictSearchLoadSettings(){
    //log("sztakidictSearchLoadSettings()");
    for (i=1; i<=SZTAKIDICT_NUM_DICTIONARIES; i++){
        document.getElementById("sztakidictURL"+i).value = sztakidictSearchPrefs.getCharPref("url"+i);
        document.getElementById("sztakidictMenuText"+i).value = sztakidictSearchPrefs.getCharPref("menutext"+i);
        document.getElementById("sztakidictAccessKey"+i).value = sztakidictSearchPrefs.getCharPref("accesskey"+i);
    }

     window.sizeToContent(); 
}



function sztakidictSearchCheckDollarSign(str){
    //log("sztakidictSearchCheckDollarSign(str)");

    ind = str.indexOf('$');
    if (ind == -1){
        return false;
    }
    if (ind != str.lastIndexOf('$')){
        return false;
    }
    return true;
}



function sztakidictPopItUp(url)
{
        if (!sztakidictWindow.closed && sztakidictWindow.location)
        {
                sztakidictWindow.arguments[0].searchurl = url;
        }
        else 
        		{       		
                sztakidictWindow=window.openDialog(
                'chrome://sztakidict/content/sztakidictShow.xul',
                'name',
                'dialog=no,top=1,width=500,height=350,toolbar=no,scrollbars=yes'
                 , {searchurl : url } );
                if (!sztakidictWindow.opener) { sztakidictWindow.opener = self; }
             }
        if (sztakidictWindow.focus) {sztakidictWindow.focus(); }
        return false;
}

